import { Environment, Implementation, WidgetData, ImplementationConfiguration } from '@webprovisions/platform';
export declare function attach(widget: WidgetData, ...triggerElements: HTMLElement[]): Promise<WidgetData>;
export declare function scan(implementation: Implementation, rootElement?: HTMLElement | Document): Promise<WidgetData[]>;
export declare type ConfigurationHandler = (...args) => void;
/**
 * A bootstrapped `Implementation` with additional extension methods.
 */
export interface BootstrappedImplementation extends Implementation {
    scan: (rootElement?: HTMLElement | Document) => Promise<WidgetData[]>;
    attach: (widget: WidgetData, ...triggerElements: HTMLElement[]) => Promise<WidgetData>;
}
export interface BootstrappedEnvironment extends Environment {
    configure: (selector, configFn) => void;
}
export default function bootstrapImplementation(config: ImplementationConfiguration, environment: BootstrappedEnvironment, createConfigurationHandlers: () => ConfigurationHandler[], rootElementOrResolver: HTMLElement | (() => HTMLElement)): Promise<BootstrappedImplementation>;
